%% Ziegler Nichols tuning
clear all; clc;
Kc=2; % set the controller in the proportional mode
Hc=tf(Kc,1);
Hsm=1;
Hs=1;
Hu=tf([1],[1,2,1,0]);
Hb=series(Hc,Hu);
feedbsign=-1; Hfeedb=feedback(Hb,Hsm,feedbsign)

Tfinal=100; [y,t]=step(Hfeedb,Tfinal);
plot(t,y);

%% Close loop transfer function for with the controller is set as PI
Kp=2*0.45; Ti=6.2/1.2;
Hp=tf(Kp,1) %proportional term
Hi=tf(Kp,[Ti,0]) %integram term
Hc=parallel(Hp,Hi) %controller transfer function

Hb=series(Hc,Hu)
feedbsign=-1; Hfeedb=feedback(Hb,Hsm,feedbsign)

%% Check stability criteria
p=pole(Hfeedb)
pzmap(Hfeedb)

%% step response for set point
Tfinal=200; [y,t]=step(Hfeedb,Tfinal);
plot(t,y);
